=== src/cfg/CMakeLists.txt ===
# Aseprite Config Library
# Copyright (c) 2014, 2015 David Capello

add_library(cfg-lib cfg.cpp)
