=== src/fixmath/CMakeLists.txt ===
# Aseprite Fixmath Library
# Based on Allegro library by Shawn Hargreaves

add_library(fixmath-lib
  fixmath.cpp)
