=== src/flic/CMakeLists.txt ===
# Aseprite FLIC Library
# Copyright (c) 2015 David Capello

add_library(flic-lib decoder.cpp encoder.cpp stdio.cpp)
