=== debian/changelog ===
aseprite (1.1.6+ds-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Adjust debian/rules for new git submodule 'observable'.

 -- Tobias Hansen <thansen@debian.org>  Mon, 11 Jul 2016 22:42:26 +0100

aseprite (1.1.5.7+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Tobias Hansen <thansen@debian.org>  Tue, 21 Jun 2016 15:28:59 +0100

aseprite (1.1.5.2+ds-1) unstable; urgency=medium

  * New upstream release.
  * Adjust debian/rules for new git submodule 'clip'.

 -- Tobias Hansen <thansen@debian.org>  Mon, 09 May 2016 22:14:46 +0100

aseprite (1.1.4.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Remove find_freetype.patch, applied upstream.
  * Bump Standards-Version to 3.9.8.

 -- Tobias Hansen <thansen@debian.org>  Wed, 20 Apr 2016 19:37:24 +0100

aseprite (1.1.3+ds-4) unstable; urgency=medium

  * Team upload.
  * Do not use PATH_MAX on hurd, but use the realpath(3) feature to
    allocate the memory itself (Closes: #821764)

 -- Tobias Frost <tobi@debian.org>  Tue, 19 Apr 2016 21:06:09 +0200

aseprite (1.1.3+ds-3) unstable; urgency=medium

  * Add paragraphs for duktape and simpleini to d/copyright.

 -- Tobias Hansen <thansen@debian.org>  Mon, 14 Mar 2016 14:07:39 +0000

aseprite (1.1.3+ds-2) unstable; urgency=medium

  * Update and readd patch disable-resize_image_tests.patch,
    which is still required to build on i386.
  * Bump Standards-Version to 3.9.7.

 -- Tobias Hansen <thansen@debian.org>  Tue, 08 Mar 2016 13:53:42 +0000

aseprite (1.1.3+ds-1) unstable; urgency=medium

  [ Tobias Hansen ]
  * New upstream release. (Closes: #816222)
  * New Build-Depends:
    - libcurl4-gnutls-dev
    - libfreetype6-dev
    - libmodpbase64-dev
    (New patches find_freetype.patch, shared_modp_b64.patch)
  * Include third party libraries duktape and simpleini.
    (New patch third_party_cmakelists.patch)
  * Include pixman-combine32.h in debian directory.
    (New patch find-pixman-combine32.patch)
  * Remove patches no longer needed:
    - no-third_party-dir.patch
    - define-O_BINARY.patch
    - giflib-4.1.6.patch
    - fix-unittests.patch
    - disable-file-and-gif-tests.patch
    - disable-resize_image_tests.patch
    - resizing_from_options_gui.patch
    - find_libpixman.patch
    - dont_use_x86_assembly.patch
  * Remove menu file.
  * Change Vcs-* fields in d/control to use https.
  * Update man file.

  [ Tobias Frost ]
  * Removing libpng16.patch, as it is no longer needed with this version.

 -- Tobias Hansen <thansen@debian.org>  Tue, 08 Mar 2016 02:24:58 +0000
