=== debian/control ===
Source: aseprite
Section: graphics
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>
Build-Depends: debhelper (>= 9),
               cmake,
               pkg-config,
               libcurl4-gnutls-dev,
               libpng-dev,
               libgif-dev,
               libjpeg-dev,
               liballegro4-dev,
               libloadpng4-dev,
               zlib1g-dev,
               libtinyxml-dev,
               libpixman-1-dev,
               libfreetype6-dev,
               libgtest-dev,
               libmodpbase64-dev
Standards-Version: 3.9.8
Homepage: http://www.aseprite.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-games/aseprite.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/aseprite.git

Package: aseprite
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sprite and pixel art editor
 ASEPRITE (aka ASE, Allegro Sprite Editor) is an open source program to
 create animated sprites & pixel art. Sprites are little images that can
 be used in your website or in a video game. You can draw characters with
 movement, intros, textures, patterns, backgrounds, logos, color palettes,
 isometric levels, etc.
